"use strict";

let mongoose 				= 	require ('mongoose'),
	db 						= 	mongoose.connection,
	_						= 	require ('underscore'),
	utilities   			=   require ('../utilities/index'),
	config					= 	{},
	env 					= 	process.env.NODE_ENV || 'development',
	//models 					= 	mongoose.models,
	jobFunctions 			= 	{},
	jobIntervals 			= 	{};


// mongoose.Promise = require('bluebird');

//// Public --------------------------------------------------------------------------------------

module.exports.startAllJobs = () => _.each (config.jobs, (chore, name) => jobIntervals [ name.toLowerCase() ] = jobFunctions [ 'start'+name ] () );
module.exports.stopAllJobs = () => _.each (config.jobs, (chore, name) => jobFunctions['stop'+name]() );

module.exports.init = function (options) {

	if (options && _.isObject(options)) _.extend (config, options);

	// Set each start chore function
	_.each (config.jobs, (chore, name) => jobFunctions['start'+name] = () => setInterval ( () => chore.fn(), chore.interval) );

	// Set each stop Chore functions
	_.each (config.jobs, (chore, name) => jobFunctions['stop'+name] = () => clearInterval ( jobIntervals [ name.toLowerCase() ] ) );

	module.exports.startAllJobs();

}