"use strict";

let fs 					= 	require('fs'),
	requireDirectory 	= 	require('require-directory'),
	env                 =   process.env.NODE_ENV || 'development',
	secrets 			= 	require('./secrets.js'),
	dbName 				= 	process.env.testing === 'true' ? 'test' : 'db',

	data                =   {
                                development:    {
                                                    uri: 		'mongodb://localhost:27000/' + dbName,
                                                    dbOptions: 	{

																	auto_reconnect: false,
																	reconnectWait: 	5000,
																	//user: 			"devuser",
																	//pass: 			secrets.dbPass,
																	/*server: {
																		ssl: 			true,
																		sslCert: 		fs.readFileSync('/etc/ssl/mongodbDev.crt'),
																		sslKey: 		fs.readFileSync('/etc/ssl/mongodbDev.key')
																	}*/
																},
                                                },

                                staging:        {
                                                    uri: 		'mongodb://localhost:27000/' + dbName,
                                                    dbOptions: 	{
																	//ssl: 			false,
																	auto_reconnect: true,
																	reconnectWait: 	5000,
																	user: 			"stguser",
																	pass: 			secrets.dbPass
																},
                                                },

                                production:     {
                                                    uri: 		'mongodb://db1:27000/' + dbName + ', mongodb://db2:27000, mongodb://db3:27000' ,
                                                    dbOptions: 	{
																	//ssl: 			false,
																	auto_reconnect: true,
																	reconnectWait: 	5000,
																	replset: 		{ rs_name: 'shard_0' },
																	user: 			"produser",
																	pass: 			secrets.dbPass
																},
                                                },
                            },
    defaultSchemaOptions =  { safe: true, read: "sp" },
	models 				= 	requireDirectory(module, './models');

exports.uri = data[env].uri;
exports.dbOptions = data[env].dbOptions;
exports.defaultSchemaOptions = defaultSchemaOptions
exports.models = models;