"use strict";

let loggerLevels        =   {
                                levels: { error: 0, warn: 1, info: 2, verbose: 3, debug: 4, silly: 5 },
                                colors: { info: 'green', warn: 'yellow', error: 'red', critical: 'red' }
                            },

    timestampFunc       =   () => Date.now(),

    console             =   {
                                development: {
                                    enabled: true,
                                    level:'debug',
                                    colorize: 'true',
                                    timestamp: timestampFunc
                                },

                                staging: {
                                    enabled:    false,
                                    level:      'warn',
                                    colorize:   'true',
                                    timestamp:  timestampFunc
                                },

                                production: {
                                    enabled:    false,
                                    level:      'error',
                                    colorize:   'true',
                                    timestamp:  timestampFunc
                                }

                            },

    file             =   {
                                development: {
                                    enabled:    false,
                                    level:      'debug',
                                    filename:   "",
                                    colorize:   'true',
                                    timestamp:  timestampFunc
                                },

                                staging: {
                                    enabled:    false,
                                    level:      'warn',
                                    filename:   "",
                                    colorize:   'true',
                                    timestamp:  timestampFunc
                                },

                                production: {
                                    enabled:    false,
                                    level:      'error',
                                    filename:   "",
                                    colorize:   'true',
                                    timestamp:  timestampFunc
                                }

                            },

    slack               =   {
                                development: {
                                    enabled: false,
                                    hook_url: "",
                                    channel: "",
                                    username: "",
                                    level: 'error',
                                    handleExceptions : true
                                },

                                staging: {
                                    enabled: false,
                                    hook_url: "",
                                    channel: "",
                                    username: "",
                                    level: 'error',
                                    handleExceptions : true
                                },

                                production: {
                                    enabled: false,
                                    hook_url: "",
                                    channel: "",
                                    username: "",
                                    level: 'error',
                                    handleExceptions : true
                                }

                            };


exports.loggerLevels = loggerLevels;
exports.console = console;
exports.file = file;
exports.slack = slack;