/*"use strict";

let _ =                     require('underscore'),
    AWS =                   require('aws-sdk'),
    sns =                   null,
    models =                require ('mongoose').models,
    utilities =             require('../../utilities'),
    config =                {},

    logErrorAndReturn =     function (e, result, callback) {
                                let err = null;
                                if (e) {
                                    err = new utilities.error.aws (e.code);
                                    if (err.code === 824 || err.code === 806) utilities.logger.warn(e);
                                    else {
                                        utilities.logger.error(err);
                                        utilities.logger.error(e);
                                    }
                                }
                                if (callback) return callback (err, result);
                            };


//// Public ---------------------------------------------------------------------------------------

module.exports.init = function (options) {
    utilities.logger.info('framework/notify/bin/awssns init');
    if (options) _.extend (config, options);
    AWS.config.update (_.pick(config, 'accessKeyId', 'secretAccessKey', 'region'));
    sns = new AWS.SNS({region: config.region});
};

module.exports.addDevice = function (data, callback) {
    utilities.logger.info('framework/notify/bin/awssns addDevice');
    sns.createPlatformEndpoint ( data, (e, result) => logErrorAndReturn (e, result, callback) );
};

module.exports.removeDevice = function (data, callback) {
    utilities.logger.info('framework/notify/bin/awssns removeDevice');
    sns.deleteEndpoint ( data, (e, result) => logErrorAndReturn (e, result, callback) );
};

module.exports.setEndpointAttributes = function (data, callback) {
    utilities.logger.info('framework/notify/bin/awssns setEndpointAttributes');
    sns.setEndpointAttributes ( data, (e, result) => logErrorAndReturn (e, result, callback) );
};

module.exports.getEndpointAttributes = function (data, callback) {
    utilities.logger.info('framework/notify/bin/awssns getEndpointAttributes');
    sns.getEndpointAttributes ( data, (e, result) => logErrorAndReturn (e, result, callback) );
};

module.exports.sendNotification = function (data, callback) {
    utilities.logger.info('framework/notify/bin/awssns sendNotification');
    sns.publish ( data, (e, result) => logErrorAndReturn (e, result, callback) );
}*/