"use strict";

let env 			= 	process.env.NODE_ENV || 'development',
	sandbox  		= 	( env === 'development' || env === "staging" );


module.exports = {
    services: {
    	awssns: {
	    	enabled: 				true,
	    	region:                 'us-west-2',
	    	accessKeyId:            process.env.AWS_ACCESS_KEY_ID || "",
	    	secretAccessKey:        process.env.AWS_SECRET_KEY || "",
	    	//apnsId: 				sandbox ? "APNS_SANDBOX" : "APNS",
	    	apnsId: 				"APNS",
	    	appName: 				"Shufl"
	    }
    },

    notifications: {
		test: { 
			message: 	"Howdy pardner!",
			sound: 		'bingbong.aiff',
		},
	}
};

let modexpsns = module.exports.services.awssns;

//PlatformApplicationArn: 'arn:aws:sns:us-west-2:212702454102:app/APNS/shufl',
//PlatformApplicationArn: 'arn:aws:sns:us-west-2:212702454102:app/APNS_SANDBOX/Shufl',

modexpsns.PlatformApplicationArn = 'arn:aws:sns:' + modexpsns.region + ':212702454102:app/' + modexpsns.apnsId + '/' + modexpsns.appName;


/*****************************************************************/
