process.env.testing = "true";

var underScore 	= 	require('underscore'),
	assert      =   require("assert"),
    should      =   require('should'),
    config      =   require('../config'),
    notify      =   require('../index.js'),

    deviceToken =   '20db796414955c4dc8d31f1733b7541123419fc6fb3e2b94973c3128d0032312',

    endpointArn = '';

notify.init(config);

describe('#notify()', function () {
	it('should try and add a device for notifications', function (done) {
        notify.addDevice ( { deviceToken: deviceToken, _id: '54848c78dc522cca3ca7fc18', platform: 'ios'} , function(e, targetArn){
            should.not.exist(e);
        	should.exist(targetArn);
            endpointArn = targetArn;
            console.log (targetArn);
        	done();
        });
    });

    it('should try and get endpoint attributes', function (done) {
        notify.getDeviceAttributes ( {endpointArn:endpointArn}, function(e, result) {
            should.not.exist(e);
            should.exist(result);
            should.exist(result.Attributes);
            should.exist(result.Attributes.Enabled);
            should.exist(result.Attributes.Token);
            done();
        });
    });

    it('should try and enable a device endpoint', function (done) {
        notify.enableDevice ( {endpointArn:endpointArn}, function(e, result) {
            should.not.exist(e);
            should.exist(result);
            done();
        });
    });


    it('should try and enable a device endpoint', function (done) {
        notify.enableDevice ( {endpointArn:endpointArn}, function(e, result) {
            should.not.exist(e);
            should.exist(result);
            done();
        });
    });

    it('should try and publish a notification', function (done) {
        var notificationsArgs = {
            person: {
                notifications: [{_id: "54848c78dc522cca3ca7fc18", platform: "ios", token:deviceToken, targetArn:endpointArn}]
            },
            id: 'test',
            badge: 2
        }
        notify.sendNotification ( notificationsArgs , function(e, result){
            should.not.exist(e);
            should.exist(result);
            console.log(result);
            done();
        });
    });

    it.skip('should try and delete a device endpoint', function (done) {
        notify.removeDevice ( {endpointArn:endpointArn}, function(e, result) {
            should.not.exist(e);
            should.exist(result);
            done();
        });
    });

});