"use strict";

let _ 				= 	require ('underscore'),
	Promise         =   require ('bluebird'),
    utilities       =   require('../utilities/index');


//// Public ---------------------------------------------------------------------------------------


exports.json = function (value, callback) {
    if (!_.isString (value) ) return callback( new utilities.error.srv(201));
    try 			{ return callback(null, JSON.parse(value)); }
    catch (error) 	{ if (error) { utilities.logger.warn(error); return callback ( new utilities.error.srv(201) );} }
};

exports.jsonPromise = function (data) {
    // return new Promise( resolve =>  );
    return Promise.resolve((typeof data === (typeof {})) ? data : JSON.parse(data));
};

exports.jsonNoCallback = data => (typeof data === (typeof {})) ? data : JSON.parse(data);

exports.mentions = function (value) {
	if (!_.isString (value) ) return [];
	let usernames = [];
    value.replace(/[@]+[A-Za-z0-9_-]+/g, val => usernames.push(val.replace('@','').toLowerCase()) );
    return usernames;
};

exports.hashtags = function (value) {
	if (!_.isString (value) ) return [];
	let hashtags = [];
    value.replace(/[#]+[A-Za-z0-9_-]+/g, val => hashtags.push( val.replace('#','').toLowerCase()) );
    return _.uniq(hashtags.slice(0,20));
};