"use strict";
let http            =   require('http'),
    _               =   require ('underscore');

function requestHTTP (options, data, callback) {
    let defaults = { 
        host: 'localhost', 
        port: 12080, 
        path: '', 
        method: 'POST',
        headers: { 'Content-Type': 'application/json' }
    }; 

    _.extend ( defaults, options );
    
    let req = http.request(defaults, function(res) {
        let resData = ''
        let cookieData = '';
        if (res.headers['set-cookie']) cookieData = res.headers['set-cookie'][0];
        //console.log('STATUS: ' + res.statusCode);
        //console.log('HEADERS: ' + JSON.stringify(res.headers));
        res.setEncoding('utf8');
        res.on('data',  chunk => resData += chunk );
        res.on('end',   ()    => callback ( null, resData, cookieData ) );

    });

    //req.setHeader("Content-Type", "application/json");
    req.on('error', e => callback(e));

    // write data to request body if not GET
    if ( defaults.method !== 'GET' ) req.write ( JSON.stringify(data) );
    req.end();
}

exports.request = function (path, method, headers, data, callback) {
    let options = { path: path, method: method, headers: headers }, httpData = {};
    
    if ( method !== 'POST') {
        options.path += '?';
        _.each (data, (value, key) => options.path += key + '=' + value + '&' );
        options.path = options.path.slice(0,options.path.length-1) //remove last character
    } else httpData = data;

    requestHTTP (options, httpData, callback);
}

