"use strict";

let underScore =    require('underscore'),
    models =        require ('mongoose').models,    
    request =       require ('request'),
    utilities =     {
                        logger: require('../../logger/index'),
                        error: require('../../error/index')
                    },
    config =        {
                        sandboxURL: "https://svcs.sandbox.paypal.com/AdaptivePayments/Pay",
                        liveURL: "",
                        sandboxAppId: "APP-80W284485P519543T", //Standard Sandbox App ID
                        liveAppId: "",
                        headers: {
                            // Sandbox API credentials for the API Caller account
                            "X-PAYPAL-SECURITY-USERID":       "canute_api1.ceeser.com",
                            "X-PAYPAL-SECURITY-PASSWORD":     "7WLQ6T2ENYV87WJJ",
                            "X-PAYPAL-SECURITY-SIGNATURE":    "An5ns1Kso7MWUdW4ErQKJJJ4qi4-AgygdAZZe1G9grGFQf0UWvYbY1dw",
                            
                            // Global Application ID
                            //"X-PAYPAL-APPLICATION-ID":        "",

                            // Input and output formats
                            "X-PAYPAL-REQUEST-DATA-FORMAT":   "JSON",
                            "X-PAYPAL-RESPONSE-DATA-FORMAT":  "JSON"
                        },
                        requestEnvelope: { errorLanguage: "en_US", detailLevel: "ReturnAll" },
                    },
    env =           process.env.NODE_ENV || 'development';

    if ("development" === env || "staging" === env) {
        config.baseURL = config.sandboxURL;
        config.headers["X-PAYPAL-APPLICATION-ID"] = config.sandboxAppId;
    } else {
        config.baseURL = config.liveURL;
        config.headers["X-PAYPAL-APPLICATION-ID"] = config.liveAppId;
    }

    let restDefaults =  {
                            json: true,
                            uri: config.baseURL,
                            method: 'POST',
                            body: {},
                            headers: config.headers
                        };

function init (options) {
    utilities.logger.info('framework/utilities/bin/transact init');
    if (options) underScore.extend (config, options);
}

//// Public ---------------------------------------------------------------------------------------

exports.init = init;

exports.pay = function (data, callback) { //data = {receiver: array, currencyCode: String} -> e.g. [ { amount: "1.00", email: "ahsokatano001@gmail.com" } ]
    utilities.logger.info('framework/utilities/bin/transact pay');
    
    let parameters = {
        actionType :        "PAY",
        currencyCode:       data.currencyCode,
        receiverList:       { receiver: data.receiver },
        returnUrl:          "http://www.example.com/success.html",
        cancelUrl:          "http://www.example.com/failure.html",
        requestEnvelope:    config.requestEnvelope,
    };

    request ( underScore.extend ({}, restDefaults, { body: parameters }), function (e, res, body) {
        if (e) return callback (new utilities.error.ppl(1000));
        if (body.responseEnvelope.ack !== 'Success') {
            utilities.logger.error(body);
            return callback ( new utilities.error.ppl(1000) );
        }
        return callback (null, {payKey: body.payKey, correlationId: body.responseEnvelope.correlationId} );
    });
};


init();